/*
Bellaciao: a Salut à Toi frontend
Copyright (C) 2011  Jérôme Poisson (goffi@goffi.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef BELLACIAO_H
#define BELLACIAO_H


#include <QtGui>
#include "ui_main_win.h"
#include "contact_list.h"
#include "bridge.h"
#include "session.h"
#include "contact.h"

class Bellaciao : public QMainWindow, private Ui::MainWindow
{
    Q_OBJECT

    public:
        static Bellaciao* getInstance();
        void connectProfiles();

    protected:
        Bellaciao();
        

    private slots:
        void quit();
        void showSettings();
        void on_actionToggle_fullscreen_triggered();
        //D-Bus slots
        void connected(const QString& profile);
        void addContact(const QString& jid, StringDict attributes, const QStringList& groups, const QString& profile);

    private:
        void fillContactList(const QString& profile);
        static Bellaciao* _instance;
        Bridge* m_bridge;
        Session* m_session;
        ContactList* m_contactList;
};

#endif
